--
-- Uwe R. Zimmer, Australia, July 2011
--

with Swarm_Data;       use Swarm_Data;
with Swarm_Structures; use Swarm_Structures;

package body Vehicle_Task_Id is

   use Swarm_Vectors;

   --

   function Id_Task (Id : Task_Id) return Swarm_Element_Index is

   begin
      Swarm_Lock.Lock_Read;
      for Element_Index in First_Index (Swarm_State) .. Last_Index (Swarm_State) loop
         if Element (Swarm_State, Element_Index).Process_Id = Id then
            Swarm_Lock.Unlock_Read;
            return (Element_Index);
         end if;
      end loop;
      Swarm_Lock.Unlock_Read;
      raise No_Such_Task;
   end Id_Task;

   --

   function Id_Task (Ix : Swarm_Element_Index) return Task_Id is

   begin
      return Element (Swarm_State, Ix).Process_Id;
   end Id_Task;

end Vehicle_Task_Id;
