--
-- Uwe R. Zimmer, Australia, July 2011
--

with Swarm_Structures_Base;      use Swarm_Structures_Base;
with Vectors_3D;                 use Vectors_3D;
with Vehicle_Message_Type;       use Vehicle_Message_Type;

package Vehicle_Interface is

   function Position     return Positions;
   function Velocity     return Velocities;
   function Acceleration return Accelerations;

   procedure Set_Destination (V : Vector_3D);
   procedure Set_Throttle    (T : Throttle_T);
   -- Throttle automatically switched to Idle_Throttle is the destination has been reached.
   function Throttle_Is_On_Idle return Boolean;

   procedure Send    (Message :     Inter_Vehicle_Messages);
   procedure Receive (Message : out Inter_Vehicle_Messages); -- blocking if no messages
   function Messages_Waiting return Boolean;

   function Current_Charge    return Vehicle_Charges;
   function Discharge_Per_Sec return Float;

   function Energy_Globes_Around return Energy_Globes_A;

   procedure Wait_For_Next_Physics_Update;
   -- blocking until the underlying physics engine updated swarm and globe positions.

end Vehicle_Interface;
